diff -Nru sql/sql_parse.cc sql/sql_parse.cc
--- sql/sql_parse.cc	2011-05-27 11:02:49.000000000 +0200
+++ sql/sql_parse.cc	2011-05-27 10:50:57.000000000 +0200
@@ -27,7 +27,7 @@
 #include "sp_cache.h"
 #include "events.h"
 #include "sql_trigger.h"
-
+#include "probes_mysql.h"
 /**
   @defgroup Runtime_Environment Runtime Environment
   @{
@@ -794,6 +794,7 @@
   net_new_transaction(net);
 
   packet_length= my_net_read(net);
+
 #if defined(ENABLED_PROFILING) && defined(COMMUNITY_SERVER)
   thd->profiling.start_new_query();
 #endif
@@ -958,6 +959,10 @@
   DBUG_ENTER("dispatch_command");
   DBUG_PRINT("info",("packet: '%*.s'; command: %d", packet_length, packet, command));
 
+  MYSQL_COMMAND_START(thd->thread_id, command,
+                      thd->security_ctx->priv_user,
+                      (char *) thd->security_ctx->host_or_ip);
+
   thd->command=command;
   /*
     Commands which always take a long time are logged into
@@ -1197,6 +1202,11 @@
   {
     if (alloc_query(thd, packet, packet_length))
       break;					// fatal error is set
+    MYSQL_QUERY_START(thd->query, thd->thread_id,
+                      (char *) (thd->db ? thd->db : ""),
+                      thd->security_ctx->priv_user,
+                      (char *) thd->security_ctx->host_or_ip);
+
     char *packet_end= thd->query + thd->query_length;
     /* 'b' stands for 'buffer' parameter', special for 'my_snprintf' */
     const char* end_of_stmt= NULL;
@@ -1233,12 +1243,22 @@
         length--;
       }
 
+      if (MYSQL_QUERY_DONE_ENABLED())
+	{
+	  MYSQL_QUERY_DONE(thd->is_error());
+	}
+
 #if defined(ENABLED_PROFILING) && defined(COMMUNITY_SERVER)
       thd->profiling.finish_current_query();
       thd->profiling.start_new_query("continuing");
       thd->profiling.set_query_source(beginning_of_next_stmt, length);
 #endif
 
+      MYSQL_QUERY_START(beginning_of_next_stmt, thd->thread_id,
+                        (char *) (thd->db ? thd->db : ""),
+                        thd->security_ctx->priv_user,
+                        (char *) thd->security_ctx->host_or_ip);
+
       VOID(pthread_mutex_lock(&LOCK_thread_count));
       thd->query_length= length;
       thd->query= beginning_of_next_stmt;
@@ -1598,6 +1618,16 @@
   VOID(pthread_mutex_unlock(&LOCK_thread_count));
   thd->packet.shrink(thd->variables.net_buffer_length);	// Reclaim some memory
   free_root(thd->mem_root,MYF(MY_KEEP_PREALLOC));
+  if (MYSQL_QUERY_DONE_ENABLED() || MYSQL_COMMAND_DONE_ENABLED())
+    {
+      int res;
+      res= (int) thd->is_error();
+      if (command == COM_QUERY)
+	{
+	  MYSQL_QUERY_DONE(res);
+	}
+      MYSQL_COMMAND_DONE(res);
+    }
   DBUG_RETURN(error);
 }
 
@@ -3014,6 +3044,7 @@
       goto error;
     DBUG_ASSERT(select_lex->offset_limit == 0);
     unit->set_limit(select_lex);
+    MYSQL_UPDATE_START(thd->query);
     res= (up_result= mysql_update(thd, all_tables,
                                   select_lex->item_list,
                                   lex->value_list,
@@ -3082,7 +3113,7 @@
 #ifdef HAVE_REPLICATION
     }  /* unlikely */
 #endif
-
+    MYSQL_MULTI_UPDATE_START(thd->query);
     res= mysql_multi_update(thd, all_tables,
                             &select_lex->item_list,
                             &lex->value_list,
@@ -3134,7 +3165,7 @@
       res= 1;
       break;
     }
-
+    MYSQL_INSERT_START(thd->query);
     res= mysql_insert(thd, all_tables, lex->field_list, lex->many_values,
 		      lex->update_list, lex->value_list,
                       lex->duplicates, lex->ignore);
@@ -3177,6 +3208,7 @@
 
     if (!(res= open_and_lock_tables(thd, all_tables)))
     {
+      MYSQL_INSERT_SELECT_START(thd->query);
       /* Skip first table, which is the table we are inserting in */
       TABLE_LIST *second_table= first_table->next_local;
       select_lex->table_list.first= (uchar*) second_table;
@@ -3262,11 +3294,12 @@
       res= 1;
       break;
     }
-
+    MYSQL_DELETE_START(thd->query);
     res = mysql_delete(thd, all_tables, select_lex->where,
                        &select_lex->order_list,
                        unit->select_limit_cnt, select_lex->options,
                        FALSE);
+    MYSQL_DELETE_DONE(res, (ulong) thd->row_count_func);
     break;
   }
   case SQLCOM_DELETE_MULTI:
@@ -3293,6 +3326,7 @@
       goto error;
 
     thd_proc_info(thd, "init");
+    MYSQL_MULTI_DELETE_START(thd->query);
     if ((res= open_and_lock_tables(thd, all_tables)))
       break;
 
@@ -5008,6 +5042,7 @@
     {
       if (!result && !(result= new select_send()))
         return 1;                               /* purecov: inspected */
+      MYSQL_SELECT_START(thd->query);
       query_cache_store_query(thd, all_tables);
       res= handle_select(thd, lex, result, 0);
       if (result != lex->result)
@@ -5861,6 +5896,7 @@
 void mysql_parse(THD *thd, const char *inBuf, uint length,
                  const char ** found_semicolon)
 {
+  int error;
   DBUG_ENTER("mysql_parse");
 
   DBUG_EXECUTE_IF("parser_debug", turn_parser_debug_on(););
@@ -5929,7 +5965,16 @@
             thd->server_status|= SERVER_MORE_RESULTS_EXISTS;
           }
           lex->set_trg_event_type_for_tables();
-          mysql_execute_command(thd);
+          MYSQL_QUERY_EXEC_START(thd->query,
+                                 thd->thread_id,
+                                 (char *) (thd->db ? thd->db : ""),
+                                 thd->security_ctx->priv_user,
+                                 (char *) thd->security_ctx->host_or_ip,
+                                 0);
+
+          error= mysql_execute_command(thd);
+          MYSQL_QUERY_EXEC_DONE(error);
+
 	}
       }
     }
@@ -7784,6 +7829,8 @@
 {
   DBUG_ASSERT(thd->m_parser_state == NULL);
 
+  MYSQL_QUERY_PARSE_START(thd->query);
+
   /* Backup creation context. */
 
   Object_creation_ctx *backup_ctx= NULL;
@@ -7815,6 +7862,8 @@
 
   /* That's it. */
 
+  MYSQL_QUERY_PARSE_DONE(mysql_parse_status || thd->is_fatal_error);
+
   return mysql_parse_status || thd->is_fatal_error;
 }
 
diff -Nru sql/sql_prepare.cc sql/sql_prepare.cc
--- sql/sql_prepare.cc	2011-05-27 11:02:49.000000000 +0200
+++ sql/sql_prepare.cc	2011-05-27 10:50:57.000000000 +0200
@@ -85,6 +85,7 @@
 
 #include "mysql_priv.h"
 #include "sql_select.h" // for JOIN
+#include "probes_mysql.h"
 #include "sql_cursor.h"
 #include "sp_head.h"
 #include "sp.h"
@@ -3567,7 +3568,14 @@
     if (query_cache_send_result_to_client(thd, thd->query,
                                           thd->query_length) <= 0)
     {
+      MYSQL_QUERY_EXEC_START(thd->query,
+                             thd->thread_id,
+                             (char *) (thd->db ? thd->db : ""),
+                             thd->security_ctx->priv_user,
+                             (char *) thd->security_ctx->host_or_ip,
+                             1);
       error= mysql_execute_command(thd);
+      MYSQL_QUERY_EXEC_DONE(error);
     }
   }
 
diff -Nru sql/sql_select.cc sql/sql_select.cc
--- sql/sql_select.cc	2011-05-27 11:02:49.000000000 +0200
+++ sql/sql_select.cc	2011-05-27 10:50:57.000000000 +0200
@@ -31,6 +31,7 @@
 #include "mysql_priv.h"
 #include "sql_select.h"
 #include "sql_cursor.h"
+#include "probes_mysql.h"
 
 #include <m_ctype.h>
 #include <my_bit.h>
@@ -240,6 +241,7 @@
   bool res;
   register SELECT_LEX *select_lex = &lex->select_lex;
   DBUG_ENTER("handle_select");
+  MYSQL_SELECT_START(thd->query);
 
   if (select_lex->master_unit()->is_union() || 
       select_lex->master_unit()->fake_select_lex)
@@ -273,6 +275,8 @@
   if (unlikely(res))
     result->abort();
 
+  MYSQL_SELECT_DONE((int) res, (ulong) thd->limit_found_rows);
+
   DBUG_RETURN(res);
 }
 
diff -Nru sql/sql_update.cc sql/sql_update.cc
--- sql/sql_update.cc	2011-05-27 11:02:49.000000000 +0200
+++ sql/sql_update.cc	2011-05-27 10:50:57.000000000 +0200
@@ -24,6 +24,8 @@
 #include "sp_head.h"
 #include "sql_trigger.h"
 
+#include "probes_mysql.h"
+
 /* Return 0 if row hasn't changed */
 
 bool compare_record(TABLE *table)
@@ -209,7 +211,10 @@
   for ( ; ; )
   {
     if (open_tables(thd, &table_list, &table_count, 0))
-      DBUG_RETURN(1);
+      {
+	MYSQL_UPDATE_DONE(1, 0, 0);
+	DBUG_RETURN(1);
+      }
 
     if (table_list->multitable_view)
     {
@@ -218,19 +223,26 @@
       /* pass counter value */
       thd->lex->table_count= table_count;
       /* convert to multiupdate */
+      MYSQL_UPDATE_DONE(2, 0, 0);
       DBUG_RETURN(2);
     }
     if (!lock_tables(thd, table_list, table_count, &need_reopen))
       break;
     if (!need_reopen)
-      DBUG_RETURN(1);
+      {
+	MYSQL_UPDATE_DONE(1, 0, 0);
+	DBUG_RETURN(1);
+      }
     close_tables_for_reopen(thd, &table_list);
   }
 
   if (mysql_handle_derived(thd->lex, &mysql_derived_prepare) ||
       (thd->fill_derived_tables() &&
        mysql_handle_derived(thd->lex, &mysql_derived_filling)))
-    DBUG_RETURN(1);
+    {
+	MYSQL_UPDATE_DONE(1, 0, 0);
+	DBUG_RETURN(1);
+    }
 
   thd_proc_info(thd, "init");
   table= table_list->table;
@@ -292,7 +304,10 @@
 
   if (select_lex->inner_refs_list.elements &&
     fix_inner_refs(thd, all_fields, select_lex, select_lex->ref_pointer_array))
-    DBUG_RETURN(-1);
+    {
+	MYSQL_UPDATE_DONE(1, 0, 0);
+	DBUG_RETURN(-1);
+    }
 
   if (conds)
   {
@@ -320,6 +335,7 @@
   {
     free_underlaid_joins(thd, select_lex);
     my_ok(thd);				// No matching records
+    MYSQL_UPDATE_DONE(1, 0, 0);
     DBUG_RETURN(0);
   }
 #endif
@@ -333,10 +349,9 @@
     delete select;
     free_underlaid_joins(thd, select_lex);
     if (error)
-    {
-      DBUG_RETURN(1);				// Error in where
-    }
+      goto abort;
     my_ok(thd);				// No matching records
+    MYSQL_UPDATE_DONE(1, 0, 0);
     DBUG_RETURN(0);
   }
   if (!select && limit != HA_POS_ERROR)
@@ -830,7 +845,9 @@
   }
   thd->count_cuted_fields= CHECK_FIELD_IGNORE;		/* calc cuted fields */
   thd->abort_on_warning= 0;
-  DBUG_RETURN((error >= 0 || thd->is_error()) ? 1 : 0);
+  res= (error >= 0 || thd->is_error()) ? 1 : 0;
+  MYSQL_UPDATE_DONE(res, (ulong) found, (ulong) updated);
+  DBUG_RETURN(res);
 
 err:
   delete select;
@@ -841,6 +858,9 @@
     table->file->extra(HA_EXTRA_NO_KEYREAD);
   }
   thd->abort_on_warning= 0;
+
+abort:
+  MYSQL_UPDATE_DONE(1, 0, 0);
   DBUG_RETURN(1);
 }
 
@@ -1686,7 +1706,10 @@
                                                *values_for_table[offset], 0,
                                                table->triggers,
                                                TRG_EVENT_UPDATE))
-	DBUG_RETURN(1);
+	{
+	  MYSQL_MULTI_UPDATE_DONE(1, 0, 0);
+	  DBUG_RETURN(1);
+	}
 
       found++;
       if (!can_compare_record || compare_record(table))
@@ -1699,7 +1722,10 @@
           if (error == VIEW_CHECK_SKIP)
             continue;
           else if (error == VIEW_CHECK_ERROR)
-            DBUG_RETURN(1);
+	    {
+	      MYSQL_MULTI_UPDATE_DONE(1, 0, 0);
+	      DBUG_RETURN(1);
+	    }
         }
         if (!updated++)
         {
@@ -1727,6 +1753,7 @@
 
             prepare_record_for_error_message(error, table);
             table->file->print_error(error,MYF(0));
+	    MYSQL_MULTI_UPDATE_DONE(1, 0, 0);
             DBUG_RETURN(1);
           }
         }
@@ -1751,7 +1778,10 @@
       if (table->triggers &&
           table->triggers->process_triggers(thd, TRG_EVENT_UPDATE,
                                             TRG_ACTION_AFTER, TRUE))
-        DBUG_RETURN(1);
+	{
+	  MYSQL_MULTI_UPDATE_DONE(1, 0, 0);
+	  DBUG_RETURN(1);
+	}
     }
     else
     {
@@ -1792,12 +1822,14 @@
                                     tmp_table_param + offset, error, 1))
         {
           do_update= 0;
+	  MYSQL_MULTI_UPDATE_DONE(1, 0, 0);
           DBUG_RETURN(1);			// Not a table_is_full error
         }
         found++;
       }
     }
   }
+  MYSQL_MULTI_UPDATE_DONE(0, (ulong) found, (ulong) updated);
   DBUG_RETURN(0);
 }
 
diff -Nru storage/archive/Makefile.am storage/archive/Makefile.am
--- storage/archive/Makefile.am	2011-05-27 11:02:47.000000000 +0200
+++ storage/archive/Makefile.am	2011-05-27 10:50:57.000000000 +0200
@@ -66,5 +66,22 @@
 
 
 EXTRA_DIST =		CMakeLists.txt plug.in
+
+if HAVE_DTRACE_DASH_G
+abs_top_srcdir = @abs_top_srcdir@
+libarchive_a_LIBADD = probes_mysql.o
+libarchive_a_DEPENDENCIES = probes_mysql.o dtrace_files dtrace_providers
+CLEANFILES = probes_mysql.o dtrace_files dtrace_providers
+DTRACEFILES = libarchive_a-ha_archive.o
+DTRACEPROVIDER = $(abs_top_srcdir)/sql/probes_mysql.d
+
+dtrace_files:
+	echo $(DTRACEFILES) > $@
+dtrace_providers:
+	echo $(DTRACEPROVIDER) > $@
+probes_mysql.o: $(DTRACEPROVIDER) $(DTRACEFILES)
+	$(DTRACE) $(DTRACEFLAGS) -G -s $< $(DTRACEFILES) -o $@
+endif
+
 # Don't update the files from bitkeeper
 %::SCCS/s.%
diff -Nru storage/archive/ha_archive.cc storage/archive/ha_archive.cc
--- storage/archive/ha_archive.cc	2011-05-27 11:02:46.000000000 +0200
+++ storage/archive/ha_archive.cc	2011-05-27 10:50:57.000000000 +0200
@@ -25,6 +25,8 @@
 
 #include <mysql/plugin.h>
 
+#include "probes_mysql.h"
+
 /*
   First, if you want to understand storage engines you should look at 
   ha_example.cc and ha_example.h. 
@@ -917,7 +919,9 @@
 {
   int rc;
   DBUG_ENTER("ha_archive::index_read");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
   rc= index_read_idx(buf, active_index, key, key_len, find_flag);
+  MYSQL_INDEX_READ_ROW_DONE(rc);
   DBUG_RETURN(rc);
 }
 
@@ -960,8 +964,10 @@
 int ha_archive::index_next(uchar * buf) 
 { 
   bool found= 0;
+  int rc;
 
   DBUG_ENTER("ha_archive::index_next");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
 
   while (!(get_row(&archive, buf)))
   {
@@ -972,7 +978,9 @@
     }
   }
 
-  DBUG_RETURN(found ? 0 : HA_ERR_END_OF_FILE); 
+  rc= found ? 0 : HA_ERR_END_OF_FILE;
+  MYSQL_INDEX_READ_ROW_DONE(rc);
+  DBUG_RETURN(rc);
 }
 
 /*
@@ -1198,12 +1206,19 @@
 {
   int rc;
   DBUG_ENTER("ha_archive::rnd_next");
+  MYSQL_READ_ROW_START(table_share->db.str, table_share->table_name.str, 0);
 
   if (share->crashed)
+    {
+      MYSQL_READ_ROW_DONE(HA_ERR_CRASHED_ON_USAGE);
       DBUG_RETURN(HA_ERR_CRASHED_ON_USAGE);
+    }
 
   if (!scan_rows)
-    DBUG_RETURN(HA_ERR_END_OF_FILE);
+    {
+      MYSQL_READ_ROW_DONE(HA_ERR_END_OF_FILE);
+      DBUG_RETURN(HA_ERR_END_OF_FILE);
+    }
   scan_rows--;
 
   ha_statistic_increment(&SSV::ha_read_rnd_next_count);
@@ -1212,6 +1227,7 @@
 
   table->status=rc ? STATUS_NOT_FOUND: 0;
 
+  MYSQL_READ_ROW_DONE(rc);
   DBUG_RETURN(rc);
 }
 
@@ -1239,12 +1255,17 @@
 
 int ha_archive::rnd_pos(uchar * buf, uchar *pos)
 {
+  int rc;
   DBUG_ENTER("ha_archive::rnd_pos");
+  MYSQL_READ_ROW_START(table_share->db.str, table_share->table_name.str, 1);
   ha_statistic_increment(&SSV::ha_read_rnd_next_count);
   current_position= (my_off_t)my_get_ptr(pos, ref_length);
   if (azseek(&archive, current_position, SEEK_SET) == (my_off_t)(-1L))
     DBUG_RETURN(HA_ERR_CRASHED_ON_USAGE);
-  DBUG_RETURN(get_row(&archive, buf));
+  else
+    rc= get_row(&archive, buf);
+  MYSQL_READ_ROW_DONE(rc);
+  DBUG_RETURN(rc);
 }
 
 /*
diff -Nru storage/blackhole/Makefile.am storage/blackhole/Makefile.am
--- storage/blackhole/Makefile.am	2011-05-27 11:02:47.000000000 +0200
+++ storage/blackhole/Makefile.am	2011-05-27 10:50:57.000000000 +0200
@@ -48,5 +48,22 @@
 
 
 EXTRA_DIST =		CMakeLists.txt plug.in
+
+if HAVE_DTRACE_DASH_G
+abs_top_srcdir = @abs_top_srcdir@
+libblackhole_a_LIBADD = probes_mysql.o
+libblackhole_a_DEPENDENCIES = probes_mysql.o dtrace_files dtrace_providers
+CLEANFILES = probes_mysql.o dtrace_files dtrace_providers
+DTRACEFILES = libblackhole_a-ha_blackhole.o
+DTRACEPROVIDER = $(abs_top_srcdir)/sql/probes_mysql.d
+
+dtrace_files:
+	echo $(DTRACEFILES) > $@
+dtrace_providers:
+	echo $(DTRACEPROVIDER) > $@
+probes_mysql.o: $(DTRACEPROVIDER) $(DTRACEFILES)
+	$(DTRACE) $(DTRACEFLAGS) -G -s $< $(DTRACEFILES) -o $@
+endif
+
 # Don't update the files from bitkeeper
 %::SCCS/s.%
diff -Nru storage/blackhole/ha_blackhole.cc storage/blackhole/ha_blackhole.cc
--- storage/blackhole/ha_blackhole.cc	2011-05-27 11:02:46.000000000 +0200
+++ storage/blackhole/ha_blackhole.cc	2011-05-27 10:50:57.000000000 +0200
@@ -21,6 +21,7 @@
 #define MYSQL_SERVER 1
 #include "mysql_priv.h"
 #include "ha_blackhole.h"
+#include "probes_mysql.h"
 
 /* Static declarations for handlerton */
 
@@ -128,18 +129,25 @@
 
 int ha_blackhole::rnd_next(uchar *buf)
 {
+  int rc;
   DBUG_ENTER("ha_blackhole::rnd_next");
+  MYSQL_READ_ROW_START(table_share->db.str, table_share->table_name.str, 0);
   THD *thd= ha_thd();
   if (thd->system_thread == SYSTEM_THREAD_SLAVE_SQL && thd->query == NULL)
-    DBUG_RETURN(0);
-  DBUG_RETURN(HA_ERR_END_OF_FILE);
+    rc= 0;
+  else
+    rc= HA_ERR_END_OF_FILE;
+  MYSQL_READ_ROW_DONE(rc);
+  DBUG_RETURN(rc);
 }
 
 
 int ha_blackhole::rnd_pos(uchar * buf, uchar *pos)
 {
   DBUG_ENTER("ha_blackhole::rnd_pos");
+  MYSQL_READ_ROW_START(table_share->db.str, table_share->table_name.str, 1);
   DBUG_ASSERT(0);
+  MYSQL_READ_ROW_DONE(0);
   DBUG_RETURN(0);
 }
 
@@ -210,11 +218,14 @@
                                  key_part_map keypart_map,
                              enum ha_rkey_function find_flag)
 {
+  int rc;
   DBUG_ENTER("ha_blackhole::index_read");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
   THD *thd= ha_thd();
-  if (thd->system_thread == SYSTEM_THREAD_SLAVE_SQL && thd->query == NULL)
-    DBUG_RETURN(0);
-  DBUG_RETURN(HA_ERR_END_OF_FILE);
+  rc= (thd->system_thread == SYSTEM_THREAD_SLAVE_SQL && thd->query == NULL) ?
+    0 : HA_ERR_END_OF_FILE;
+  MYSQL_INDEX_READ_ROW_DONE(rc);
+  DBUG_RETURN(rc);
 }
 
 
@@ -222,28 +233,36 @@
                                  key_part_map keypart_map,
                                  enum ha_rkey_function find_flag)
 {
+  int rc;
   DBUG_ENTER("ha_blackhole::index_read_idx");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
   THD *thd= ha_thd();
-  if (thd->system_thread == SYSTEM_THREAD_SLAVE_SQL && thd->query == NULL)
-    DBUG_RETURN(0);
-  DBUG_RETURN(HA_ERR_END_OF_FILE);
+  rc= (thd->system_thread == SYSTEM_THREAD_SLAVE_SQL && thd->query == NULL) ?
+    0 : HA_ERR_END_OF_FILE;
+  MYSQL_INDEX_READ_ROW_DONE(rc);
+  DBUG_RETURN(rc);
 }
 
 
 int ha_blackhole::index_read_last_map(uchar * buf, const uchar * key,
                                       key_part_map keypart_map)
 {
+  int rc;
   DBUG_ENTER("ha_blackhole::index_read_last");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
   THD *thd= ha_thd();
-  if (thd->system_thread == SYSTEM_THREAD_SLAVE_SQL && thd->query == NULL)
-    DBUG_RETURN(0);
-  DBUG_RETURN(HA_ERR_END_OF_FILE);
+  rc= (thd->system_thread == SYSTEM_THREAD_SLAVE_SQL && thd->query == NULL) ?
+    0 : HA_ERR_END_OF_FILE;
+  MYSQL_INDEX_READ_ROW_DONE(rc);
+  DBUG_RETURN(rc);
 }
 
 
 int ha_blackhole::index_next(uchar * buf)
 {
   DBUG_ENTER("ha_blackhole::index_next");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
+  MYSQL_INDEX_READ_ROW_DONE(HA_ERR_END_OF_FILE);
   DBUG_RETURN(HA_ERR_END_OF_FILE);
 }
 
@@ -251,6 +270,8 @@
 int ha_blackhole::index_prev(uchar * buf)
 {
   DBUG_ENTER("ha_blackhole::index_prev");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
+  MYSQL_INDEX_READ_ROW_DONE(HA_ERR_END_OF_FILE);
   DBUG_RETURN(HA_ERR_END_OF_FILE);
 }
 
@@ -258,6 +279,8 @@
 int ha_blackhole::index_first(uchar * buf)
 {
   DBUG_ENTER("ha_blackhole::index_first");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
+  MYSQL_INDEX_READ_ROW_DONE(HA_ERR_END_OF_FILE);
   DBUG_RETURN(HA_ERR_END_OF_FILE);
 }
 
@@ -265,6 +288,8 @@
 int ha_blackhole::index_last(uchar * buf)
 {
   DBUG_ENTER("ha_blackhole::index_last");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
+  MYSQL_INDEX_READ_ROW_DONE(HA_ERR_END_OF_FILE);
   DBUG_RETURN(HA_ERR_END_OF_FILE);
 }
 
diff -Nru storage/csv/Makefile.am storage/csv/Makefile.am
--- storage/csv/Makefile.am	2011-05-27 11:02:47.000000000 +0200
+++ storage/csv/Makefile.am	2011-05-27 10:50:57.000000000 +0200
@@ -41,5 +41,22 @@
 libcsv_a_SOURCES =	transparent_file.cc ha_tina.cc
 
 EXTRA_DIST =		CMakeLists.txt plug.in
+	
+if HAVE_DTRACE_DASH_G
+abs_top_srcdir = @abs_top_srcdir@
+libcsv_a_LIBADD = probes_mysql.o
+libcsv_a_DEPENDENCIES = probes_mysql.o dtrace_files dtrace_providers
+CLEANFILES = probes_mysql.o dtrace_files dtrace_providers
+DTRACEFILES = libcsv_a-ha_tina.o
+DTRACEPROVIDER = $(abs_top_srcdir)/sql/probes_mysql.d
+
+dtrace_files:
+	echo $(DTRACEFILES) > $@
+dtrace_providers:
+	echo $(DTRACEPROVIDER) > $@
+probes_mysql.o: $(DTRACEPROVIDER) $(DTRACEFILES)
+	$(DTRACE) $(DTRACEFLAGS) -G -s $< $(DTRACEFILES) -o $@
+endif
+
 # Don't update the files from bitkeeper
 %::SCCS/s.%
diff -Nru storage/csv/ha_tina.cc storage/csv/ha_tina.cc
--- storage/csv/ha_tina.cc	2011-05-27 11:02:46.000000000 +0200
+++ storage/csv/ha_tina.cc	2011-05-27 10:50:57.000000000 +0200
@@ -48,6 +48,7 @@
 #include "mysql_priv.h"
 #include <mysql/plugin.h>
 #include "ha_tina.h"
+#include "probes_mysql.h"
 
 
 /*
@@ -1095,6 +1096,7 @@
 {
   int rc;
   DBUG_ENTER("ha_tina::rnd_next");
+  MYSQL_READ_ROW_START(table_share->db.str, table_share->table_name.str, 0);
 
   if (share->crashed)
       DBUG_RETURN(HA_ERR_CRASHED_ON_USAGE);
@@ -1105,13 +1107,19 @@
 
   /* don't scan an empty file */
   if (!local_saved_data_file_length)
-    DBUG_RETURN(HA_ERR_END_OF_FILE);
+    {
+      rc= HA_ERR_END_OF_FILE;
+      goto end;
+    }
 
   if ((rc= find_current_row(buf)))
-    DBUG_RETURN(rc);
+    goto end;
 
   stats.records++;
-  DBUG_RETURN(0);
+
+ end:
+  MYSQL_READ_ROW_DONE(rc);
+  DBUG_RETURN(rc);
 }
 
 /*
diff -Nru storage/example/Makefile.am storage/example/Makefile.am
--- storage/example/Makefile.am	2011-05-27 11:02:47.000000000 +0200
+++ storage/example/Makefile.am	2011-05-27 10:50:57.000000000 +0200
@@ -48,5 +48,23 @@
 
 
 EXTRA_DIST =		CMakeLists.txt plug.in
+
+if HAVE_DTRACE_DASH_G
+libexample_a_LIBADD = probes_mysql.o
+libexample_a_DEPENDENCIES = probes_mysql.o
+CLEANFILES =
+BUILT_SOURCES =
+DTRACEFILES = libexample_a-ha_example.o
+DTRACEPROVIDER = $(abs_top_srcdir)/sql/probes_mysql.d
+
+dtrace_files:
+	echo $(DTRACEFILES) > $@
+dtrace_providers:
+	echo $(DTRACEPROVIDER) > $@
+probes_mysql.o: $(DTRACEPROVIDER) $(DTRACEFILES)
+	$(DTRACE) $(DTRACEFLAGS) -G -s $< $(DTRACEFILES) -o $@
+endif
+
+
 # Don't update the files from bitkeeper
 %::SCCS/s.%
diff -Nru storage/example/ha_example.cc storage/example/ha_example.cc
--- storage/example/ha_example.cc	2011-05-27 11:02:46.000000000 +0200
+++ storage/example/ha_example.cc	2011-05-27 10:50:57.000000000 +0200
@@ -95,6 +95,7 @@
 #include "mysql_priv.h"
 #include "ha_example.h"
 #include <mysql/plugin.h>
+#include "probes_mysql.h"
 
 static handler *example_create_handler(handlerton *hton,
                                        TABLE_SHARE *table, 
@@ -429,6 +430,8 @@
                                __attribute__((unused)))
 {
   DBUG_ENTER("ha_example::index_read");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
+  MYSQL_INDEX_READ_ROW_DONE(HA_ERR_WRONG_COMMAND);
   DBUG_RETURN(HA_ERR_WRONG_COMMAND);
 }
 
@@ -441,6 +444,8 @@
 int ha_example::index_next(uchar *buf)
 {
   DBUG_ENTER("ha_example::index_next");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
+  MYSQL_INDEX_READ_ROW_DONE(HA_ERR_WRONG_COMMAND);
   DBUG_RETURN(HA_ERR_WRONG_COMMAND);
 }
 
@@ -453,6 +458,8 @@
 int ha_example::index_prev(uchar *buf)
 {
   DBUG_ENTER("ha_example::index_prev");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
+  MYSQL_INDEX_READ_ROW_DONE(HA_ERR_WRONG_COMMAND);
   DBUG_RETURN(HA_ERR_WRONG_COMMAND);
 }
 
@@ -470,6 +477,8 @@
 int ha_example::index_first(uchar *buf)
 {
   DBUG_ENTER("ha_example::index_first");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
+  MYSQL_INDEX_READ_ROW_DONE(HA_ERR_WRONG_COMMAND);
   DBUG_RETURN(HA_ERR_WRONG_COMMAND);
 }
 
@@ -487,6 +496,8 @@
 int ha_example::index_last(uchar *buf)
 {
   DBUG_ENTER("ha_example::index_last");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
+  MYSQL_INDEX_READ_ROW_DONE(HA_ERR_WRONG_COMMAND);
   DBUG_RETURN(HA_ERR_WRONG_COMMAND);
 }
 
@@ -534,6 +545,8 @@
 int ha_example::rnd_next(uchar *buf)
 {
   DBUG_ENTER("ha_example::rnd_next");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
+  MYSQL_INDEX_READ_ROW_DONE(HA_ERR_WRONG_COMMAND);
   DBUG_RETURN(HA_ERR_END_OF_FILE);
 }
 
@@ -582,6 +595,8 @@
 int ha_example::rnd_pos(uchar *buf, uchar *pos)
 {
   DBUG_ENTER("ha_example::rnd_pos");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
+  MYSQL_INDEX_READ_ROW_DONE(HA_ERR_WRONG_COMMAND);
   DBUG_RETURN(HA_ERR_WRONG_COMMAND);
 }
 
diff -Nru storage/federated/Makefile.am storage/federated/Makefile.am
--- storage/federated/Makefile.am	2011-05-27 11:02:47.000000000 +0200
+++ storage/federated/Makefile.am	2011-05-27 10:50:57.000000000 +0200
@@ -48,5 +48,22 @@
 
 
 EXTRA_DIST =		CMakeLists.txt plug.in
+
+if HAVE_DTRACE_DASH_G
+abs_top_srcdir = @abs_top_srcdir@
+libfederated_a_LIBADD = probes_mysql.o
+libfederated_a_DEPENDENCIES = probes_mysql.o dtrace_files dtrace_providers
+CLEANFILES = probes_mysql.o dtrace_files dtrace_providers
+DTRACEFILES = libfederated_a-ha_federated.o
+DTRACEPROVIDER = $(abs_top_srcdir)/sql/probes_mysql.d
+
+dtrace_files:
+	echo $(DTRACEFILES) > $@
+dtrace_providers:
+	echo $(DTRACEPROVIDER) > $@
+probes_mysql.o: $(DTRACEPROVIDER) $(DTRACEFILES)
+	$(DTRACE) $(DTRACEFLAGS) -G -s $< $(DTRACEFILES) -o $@
+endif
+
 # Don't update the files from bitkeeper
 %::SCCS/s.%
diff -Nru storage/federated/ha_federated.cc storage/federated/ha_federated.cc
--- storage/federated/ha_federated.cc	2011-05-27 11:02:46.000000000 +0200
+++ storage/federated/ha_federated.cc	2011-05-27 10:50:57.000000000 +0200
@@ -385,6 +385,8 @@
 
 #include <mysql/plugin.h>
 
+#include "probes_mysql.h"
+
 /* Variables for federated share methods */
 static HASH federated_open_tables;              // To track open tables
 pthread_mutex_t federated_mutex;                // To init the hash
@@ -2324,13 +2326,17 @@
 int ha_federated::index_read(uchar *buf, const uchar *key,
                              uint key_len, ha_rkey_function find_flag)
 {
+  int rc;
   DBUG_ENTER("ha_federated::index_read");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
 
   if (stored_result)
     mysql_free_result(stored_result);
-  DBUG_RETURN(index_read_idx_with_result_set(buf, active_index, key,
-                                             key_len, find_flag,
-                                             &stored_result));
+  rc= index_read_idx_with_result_set(buf, active_index, key,
+				     key_len, find_flag,
+				     &stored_result);
+  MYSQL_INDEX_READ_ROW_DONE(rc);
+  DBUG_RETURN(rc);
 }
 
 
@@ -2353,12 +2359,17 @@
   int retval;
   MYSQL_RES *mysql_result;
   DBUG_ENTER("ha_federated::index_read_idx");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
 
   if ((retval= index_read_idx_with_result_set(buf, index, key,
                                               key_len, find_flag,
                                               &mysql_result)))
-    DBUG_RETURN(retval);
+    {
+      MYSQL_INDEX_READ_ROW_DONE(retval);
+      DBUG_RETURN(retval);
+    }
   mysql_free_result(mysql_result);
+  MYSQL_INDEX_READ_ROW_DONE(0);
   DBUG_RETURN(retval);
 }
 
@@ -2478,6 +2489,7 @@
                    sizeof(sql_query_buffer),
                    &my_charset_bin);
   DBUG_ENTER("ha_federated::read_range_first");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
 
   DBUG_ASSERT(!(start_key == NULL && end_key == NULL));
 
@@ -2506,10 +2518,12 @@
   }
 
   retval= read_next(table->record[0], stored_result);
+  MYSQL_INDEX_READ_ROW_DONE(retval);
   DBUG_RETURN(retval);
 
 error:
   table->status= STATUS_NOT_FOUND;
+  MYSQL_INDEX_READ_ROW_DONE(retval);
   DBUG_RETURN(retval);
 }
 
@@ -2518,7 +2532,9 @@
 {
   int retval;
   DBUG_ENTER("ha_federated::read_range_next");
+  MYSQL_INDEX_READ_ROW_START(table_share->db.str, table_share->table_name.str);
   retval= rnd_next(table->record[0]);
+  MYSQL_INDEX_READ_ROW_DONE(retval);
   DBUG_RETURN(retval);
 }
 
@@ -2637,7 +2653,9 @@
 
 int ha_federated::rnd_next(uchar *buf)
 {
+  int rc;
   DBUG_ENTER("ha_federated::rnd_next");
+  MYSQL_READ_ROW_START(table_share->db.str, table_share->table_name.str, 0);
 
   if (stored_result == 0)
   {
@@ -2646,9 +2664,12 @@
       so we can get here _even_ if there is _no_ pre-fetched result-set!
       TODO: fix it. We can delete this in 5.1 when rnd_init() is checked.
     */
+    MYSQL_READ_ROW_DONE(1);
     DBUG_RETURN(1);
   }
-  DBUG_RETURN(read_next(buf, stored_result));
+  rc= read_next(buf, stored_result);
+  MYSQL_READ_ROW_DONE(rc);
+  DBUG_RETURN(rc);
 }
 
 
@@ -2726,6 +2747,8 @@
 {
   int result;
   DBUG_ENTER("ha_federated::rnd_pos");
+  MYSQL_READ_ROW_START(table_share->db.str, table_share->table_name.str, 1);
+
   ha_statistic_increment(&SSV::ha_read_rnd_count);
   if (table->s->primary_key != MAX_KEY)
   {
@@ -2740,6 +2763,7 @@
     result= 0;
   }
   table->status= result ? STATUS_NOT_FOUND : 0;
+  MYSQL_READ_ROW_DONE(result);
   DBUG_RETURN(result);
 }
 
diff -Nru storage/heap/Makefile.am storage/heap/Makefile.am
--- storage/heap/Makefile.am	2011-05-27 11:02:47.000000000 +0200
+++ storage/heap/Makefile.am	2011-05-27 10:50:57.000000000 +0200
@@ -51,5 +51,21 @@
 
 EXTRA_DIST =		CMakeLists.txt plug.in
 
+if HAVE_DTRACE_DASH_G
+abs_top_srcdir = @abs_top_srcdir@
+libheap_a_LIBADD = probes_mysql.o
+libheap_a_DEPENDENCIES = probes_mysql.o dtrace_files dtrace_providers
+CLEANFILES = probes_mysql.o dtrace_files dtrace_providers
+DTRACEFILES = ha_heap.o
+DTRACEPROVIDER = $(abs_top_srcdir)/sql/probes_mysql.d
+
+dtrace_files:
+	echo $(DTRACEFILES) > $@
+dtrace_providers:
+	echo $(DTRACEPROVIDER) > $@
+probes_mysql.o: $(DTRACEPROVIDER) $(DTRACEFILES)
+	$(DTRACE) $(DTRACEFLAGS) -G -s $< $(DTRACEFILES) -o $@
+endif
+
 # Don't update the files from bitkeeper
 %::SCCS/s.%
